﻿// lite Code Highlighter - javascript (jquery)
// By KUNA - http://kuna.wo.tc
// Edit and redistribute is free with GNU License
// ver 0.02

// common values
var tags = ["html", "meta", "title", "link", "script", "body", "div", "header", "a", "table", "td", "tr", "ul", "ol", "li", "hr"];
var prototypes = ["var", "new", "int", "string", "false", "true", "while", "void", "short", "static", "return", "char", "class", "extern", "null", "break", "do", "continue", "else", "if", "try", "catch", "float", "for", "goto", "byte", "switch", "undefined", "throw", "import"];

var chrIndex;
var tmpLen;
var editedHTML;

// addon Function
function isNum(value)		// value 값이 숫자인가?
{
	if (checkChar(value, "0123456789")) return true; else return false;
}

function isFin()			// chrIndex가 범위를 초과하였나?
{
	if (chrIndex < editedHTML.length) return false; else return true;
}

function chkChr(pos, str)	// pos 위치에 str 문자열을 확인
{
	if (editedHTML.length < pos + str.length) return false;
	if (editedHTML.substring(pos, pos+str.length) == str) return true; else return false;
}

function addTag(pos, str)	// pos 위치에 str 태그를 삽입
{
	editedHTML = editedHTML.substring(0, pos) + str + editedHTML.substring(pos);
	chrIndex += str.length;
}

function checkChar(str1, str2)
{
	if (str2.indexOf(str1) == -1)
	return false;
	else
	return true;
}

function chkFunction(pos, arr, applyNewPos)
{
	var cs;		// 임시로 쓰일 확인용 임시 문자열 변수
	var len;	// function의 문자열길이
	var lenLimit=10;	// function의 최대문자열길이(상수)
	// 앞 문자 확인
	if (chrIndex > 0)
	{
		cs = editedHTML.substring(chrIndex - 1, chrIndex);
		if (checkChar(cs, "\t\n ()[]&;/="))
			return false;	// 앞 문자가 \t, \n, 공백, ( 이 아닐땐 false
	}
	
	// 뒤 문자 확인
	len=0;
	var isFoundNext = false;
	
	while (len < lenLimit && chrIndex+len < editedHTML.length)
	{
		cs = editedHTML.substring(chrIndex + len, chrIndex + len + 1);
		if (checkChar(cs, "\t\n ()[]&;/="))
		{
			isFoundNext = true;
			break;	// 임시문자열이 빈칸 혹은 )일때
		}
		len += 1;
	}
	
	if (!isFoundNext) return false;	// limit 안에서 다음 문자열을 찾지 못했을 경우
	if (len==0) return false;			// 길이가 0일때
	
	// 3. 길이 맞는 function 구함
	var i;
	for (i=0; i<arr.length; i++)
	{
		if (editedHTML.substring(chrIndex-1, chrIndex+len).toUpperCase() == arr[i].toUpperCase())
		{
			// 조건에 합당하는 function을 찾았으므로, tmpIndex에 위치 저장하고 return true
			tmpLen = len;
			return true;
		}
	}
	
	// 여기까지 오면 맞는 function을 찾지 못한 것이므로 return false
	if (applyNewPos) chrIndex += len;
	return false;
}

function indexOfArr(findstr, arr, startIndex)
{
	var i;
	var resArr = new Array();
	var res = 999999;	// 임의의 최대값
	
	for (i=0; i<arr.length; i++)
	{
		resArr.push(findstr.indexOf(arr[i], startIndex));
	}
	
	for (i=0; i<resArr.length; i++)
	{
		if (res > resArr[i]) res = resArr[i];
	}
	
	return res;
}

function HighlightObj(obj) {
	var changed;
	editedHTML = $(obj).html().replace(/<br>/gi, '\n');	// BR 태그 치환
	chrIndex = 0;
	tmpIndex = 0;
	
	while (!isFin())
	{
		changed = false;
		
		// 1. 주석 검사 (1)
		if (chkChr(chrIndex, '//'))
		{
			addTag(chrIndex, "<span class='css_todo'>");
			while(!isFin())
			{
				chrIndex += 1;
				if (chkChr(chrIndex, '\n'))
				{
					chrIndex += 1;
					break;
				}
			}
			addTag(chrIndex, "</span>");
			changed = true;
		}
		
		// 2. 주석 검사 (2)
		if (chkChr(chrIndex, '/*'))
		{
			addTag(chrIndex, "<span class='css_todo'>");
			while(!isFin())
			{
				chrIndex += 1;
				if (chkChr(chrIndex, '*/'))
				{
					chrIndex += 2;	// '*/' 문자열의 길이는 2이므로...
					break;
				}
			}
			addTag(chrIndex, "</span>");
			changed = true;
		}
		
		// 3. 작은 따옴표 검사
		if (chkChr(chrIndex, "'"))
		{
			addTag(chrIndex, "<span class='css_string'>");
			while(!isFin())
			{
				chrIndex += 1;
				if (chkChr(chrIndex, "'"))
				{
					chrIndex += 1;
					break;
				}
			}
			addTag(chrIndex, "</span>");
			changed = true;
		}
		
		// 4. 큰 따옴표 검사
		if (chkChr(chrIndex, '"'))
		{
			addTag(chrIndex, "<span class='css_string'>");
			while(!isFin())
			{
				chrIndex += 1;
				if (chkChr(chrIndex, '"'))
				{
					chrIndex += 1;
					break;
				}
			}
			addTag(chrIndex, "</span>");
			changed = true;
		}
		
		// 5. 숫자 검사
		if ( isNum(editedHTML.substring(chrIndex, chrIndex+1)) )
		{
			addTag(chrIndex, "<span class='css_number'>");
			while(!isFin())
			{
				chrIndex += 1;
				if (!isNum(editedHTML.substring(chrIndex, chrIndex+1)))
					break;
			}
			addTag(chrIndex, "</span>");
			changed = true;
		}
		
		// 6. 함수 확인
		
		if (chkFunction(chrIndex, tags, false))
		{
			addTag(chrIndex - 1, "<span class='css_function'>");
			addTag(chrIndex + tmpLen, "</span>");
			chrIndex += tmpLen;
			changed = true;
		}
		
		// 7. 프로토타입 확인
		if (chkFunction(chrIndex, prototypes, true))
		{
			addTag(chrIndex - 1, "<span class='css_prototype'>");
			addTag(chrIndex + tmpLen, "</span>");
			chrIndex += tmpLen;
			changed = true;
		}
		
		// 이 조건에 해당되지 않을 경우 다음 문자열 검사
		if (!changed) chrIndex += 1;
	}
	
	// refresh org Source
	$(obj).html(editedHTML.replace(/\n/g, "<br>"));
}

// main function
function doHighlight() {
	$('pre').each(function(e) { HighlightObj(this); });
	$('code').each(function(e) { HighlightObj(this); });
}

// execute main Function when dom is loaded
$(document).ready(function(e) {
	doHighlight();
});